<?php
/**
 *   Medals System Plugin for MyBB (Medal Mangers Page)
 *   Website: http://www.ncaabbs.com
 *   Version: 1.1
 *   Copyright  2007
 *   King Butter - NCAAbbs SkunkWorks Team
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License along
 *   with this program; if not, write to the Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *   Tr eviri: www.MyBBoard.Gen.TR adna dared
 */


define("IN_MYBB", 1);

require_once './global.php';
global $db, $mybb,$config;
$lang->load("medals");

echo $headerinclude;
echo $header;

$supermod = $mybb->usergroup['issupermod'];

$cuid = $mybb->user['uid'];
$validmgrquery = $db->query("select count(*) as count from `".TABLE_PREFIX."medals_managers` where `uid`=".$cuid);
$count = $db->fetch_field($validmgrquery,"count");

if($count >= 1 || $supermod == 'yes')
{
	switch(trim($mybb->input['action']))
	{
	case $lang->award_medal:
		if (!check_auth($mybb->input['mid'],$cuid))
        	{
        	echo "Not Authorized";
        	echo $footer;
        	die();
        	}
		if ($mybb->input['Username'] == "")
		{
		show_medals_list($uid);
		die();
		}

		if (!$_POST['Username'])
		{
		echo "No POST...are you trying to hax0r me?";
		echo $footer;
		die();
		}
	award_medals($mybb->input['mid'],$mybb->input['Username']);
	break;	

	case $lang->show_awarded:
	if (!check_auth($mybb->input['mid'],$cuid))
	{
	echo "Not Authorized";
	echo $footer;
	die();
	}
	show_awarded($mybb->input['mid']);
	break;

	case $lang->suspend_medal:
	suspend_medal($mybb->input['mid'],$mybb->input['uid'],0);
	break;

	case $lang->unsuspend_medal:
	suspend_medal($mybb->input['mid'],$mybb->input['uid'],1);
	break;


	case $lang->revoke_medal:
	revoke_medal($mybb->input['mid'],$mybb->input['uid']);
	break;

	default:
	show_medals_list($cuid,$footer);
	break;

	}
}
else
{
echo "Not Authorized";
echo $footer;
die();
}


function show_medals_list($cuid,$footer)
{
global $mybb,$menu,$lang,$db,$theme,$config;
$supermod = $mybb->usergroup['issupermod'];
echo "<table border=\"0\" cellspacing=\"{$theme['borderwidth']}\" cellpadding=\"{$theme['tablespace']}\" class=\"tborder\">";
echo "<thead><tr><td class=\"thead\"><span style=\"float: center;\">{$lang->manage_medals_header}</span></td></tr></thead>";

	if ($supermod == 'yes')
	$medals_query = $db->query("select `mid`,`description` from `".TABLE_PREFIX."medals_list`");
	else
	$medals_query = $db->query("select `mid`,`description` from `".TABLE_PREFIX."medals_list` where `mid` in (select `mid` from `".TABLE_PREFIX."medals_managers` where `uid`=".$cuid.")");
	if ($db->num_rows($medals_query) <= 0)
	{
	 echo "<tr><td class=\"trow1\">No Medals Found</td></tr>";
	 echo "</table>";
	 echo $footer;
	 exit();
	}
	while($medal_list = $db->fetch_array($medals_query))
	{

	$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath'].'/medals/'.$medal_list['mid'].'.jpg';
	$listurl = $mybb->settings['bburl']."/medals.php?action={$lang->show_awarded}&mid={$medal_list['mid']}";

	echo "<tr><td class=\"tcat\" colspan=\"2\">{$lang->award_medal}: ".$medal_list['description']." ";	
	echo "<img src=\"".$imgsrc."\"> <a href=\"{$listurl}\">{$lang->show_awarded}</a></td></tr>";
	echo "<form method=\"POST\" action=\"{$_SERVER['PHP_SELF']}\">";
	echo "<input type=\"hidden\" name=\"mid\" value=\"{$medal_list['mid']}\">";
	echo "<tr><td class=\"trow1\">";
	echo "{$lang->uname}<input type=\"text\" name=\"Username\">";
	echo "<input type=\"submit\" name=\"action\" value=\"{$lang->award_medal}\"></td></tr>";
	echo "</form>";	
	}
echo "</table>";
}

function award_medals($mid,$unamesarray)
{
global $db,$mybb,$theme,$lang;
$unames = explode(",",$unamesarray);
$headeractive = 0;
$dupeheader = 0;
$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath'].'/medals/'.$mid.'.jpg';
echo "<table border=\"0\" cellspacing=\"{$theme['borderwidth']}\" cellpadding=\"{$theme['tablespace']}\" class=\"tborder\">";
echo "<thead><tr><td class=\"thead\"><span style=\"float: center;\">{$lang->award_medal}: <img src=\"".$imgsrc."\"></td></tr></span></td></tr></thead>";

	// Check for Valid UserNames
	foreach($unames as $uname)
	{
		if ($uid = username_to_uid($uname))
		{
		$dupequery = $db->query("select * from `".TABLE_PREFIX."medals_awarded` where `uid`={$uid} and `mid`={$mid}");
			if($db->num_rows($dupequery) != '0')
			$uidarray[$uname] = -1;
			else
			$uidarray[$uname] = $uid;
		}
		else
		$uidarray[$uname] = -2;
	}
	asort($uidarray);
	if (array_search("-2",$uidarray))
	{
	 echo "<tr><td class=\"tcat\">{$lang->failures}</td></tr>";
	
	}
	foreach($uidarray as $uname => $uid)
	{
		if ($uid == '-2')
		echo "<tr><td class=\"trow1\">{$uname}</td></tr>";
		else if ($uid == '-1')
		{
			if ($dupeheader == '0')
			{
			$dupeheader = 1;
			echo "<tr><td class=\"tcat\">{$lang->dupes}</td></tr>";
			}
		echo "<tr><td class=\"trow1\">{$uname}</td></tr>";
		}
		else if ($headeractive == '0')
		{
		$headeractive= 1;
		echo "<tr><td class=\"tcat\">{$lang->successes}</td></tr>";
		$db->query("insert into `".TABLE_PREFIX."medals_awarded` VALUES({$mid},{$uid},1)");
		echo "<tr><td class=\"trow1\">{$uname}</td></tr>";
		}
		else
		{
		$db->query("insert into `".TABLE_PREFIX."medals_awarded` VALUES({$mid},{$uid},1)");
		echo "<tr><td class=\"trow1\">{$uname}</td></tr>";
		}
	}
echo "</table>";
show_medals_list($cuid,$footer);
}


function show_awarded($mid)
{
global $db,$mybb,$theme,$lang;
$desc = mid_to_desc($mid);
$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath'].'/medals/'.$mid.'.jpg';
echo "<table border=\"0\" cellspacing=\"{$theme['borderwidth']}\" cellpadding=\"{$theme['tablespace']}\" class=\"tborder\">";
echo "<thead><tr><td class=\"thead\" colspan=\"2\"><span style=\"float: center;\">{$desc} {$lang->medals_awarded}: <img src=\"".$imgsrc."\"></td></tr></span></td></tr></thead>";
echo "<tr><td class=\"tcat\">Name</td><td class=\"tcat\">Actions</td></tr>";
 	$award_query = $db->query("select `uid`,`status` from `".TABLE_PREFIX."medals_awarded` where `mid`={$mid}"); 
        if ($db->num_rows($award_query) <= 0)
	{
	echo "<tr><td class=\"trow1\" colspan=\"2\">No Medals Awarded</td></tr>";
	echo $footer;
	exit();
	}
	while($award_list = $db->fetch_array($award_query))
        {

        $imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath'].'/medals/'.$mid.'.jpg';
        $suspurl = $mybb->settings['bburl']."/medals.php?action={$lang->suspend_medal}&mid={$mid}&uid={$award_list['uid']}";
        $unsuspurl = $mybb->settings['bburl']."/medals.php?action={$lang->unsuspend_medal}&mid={$mid}&uid={$award_list['uid']}";
        $revokeurl = $mybb->settings['bburl']."/medals.php?action={$lang->revoke_medal}&mid={$mid}&uid={$award_list['uid']}";
        echo "<tr><td class=\"trow1\">".uid_to_username($award_list['uid'])."</td> ";
	if ($award_list['status'] == '0')
	echo "<td class=\"trow1\"><a href=\"{$unsuspurl}\">{$lang->unsuspend_medal}</a> | ";
	else
	echo "<td class=\"trow1\"><a href=\"{$suspurl}\">{$lang->suspend_medal}</a> | ";
	echo "<a href=\"{$revokeurl}\">{$lang->revoke_medal}</a></td></tr>";
        }
echo "</table>";

}


function revoke_medal($mid,$uid)
{
global $db,$mybb,$theme,$lang;
$desc = mid_to_desc($mid);
$uname = uid_to_username($uid);
$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath'].'/medals/'.$mid.'.jpg';
echo "<table border=\"0\" cellspacing=\"{$theme['borderwidth']}\" cellpadding=\"{$theme['tablespace']}\" class=\"tborder\">";
echo "<thead><tr><td class=\"thead\" colspan=\"2\"><span style=\"float: center;\">{$desc} {$lang->revocation_status}: <img src=\"".$imgsrc."\"></td></tr></span></td></tr>";
echo "<tr><td class=\"tcat\">Name</td><td class=\"tcat\">Actions</td></tr>";
$db->query("delete from `".TABLE_PREFIX."medals_awarded` where `mid`={$mid} and `uid`={$uid}");
echo "<tr><td class=\"trow1\" colspan=\"2\">{$desc} <img src=\"{$imgsrc}\"> {$lang->medal_revoked} for ".uid_to_username($uid);
echo "</table>";
show_medals_list($cuid,$footer);

}

function suspend_medal($mid,$uid,$action)
{
global $db,$mybb,$theme,$lang;
$desc = mid_to_desc($mid);
$uname = uid_to_username($uid);
$imgsrc = $mybb->settings['bburl']."/".$mybb->settings['uploadspath'].'/medals/'.$mid.'.jpg';
echo "<table border=\"0\" cellspacing=\"{$theme['borderwidth']}\" cellpadding=\"{$theme['tablespace']}\" class=\"tborder\">";
echo "<thead><tr><td class=\"thead\" colspan=\"2\"><span style=\"float: center;\">{$desc} {$lang->revocation_status}: <img src=\"".$imgsrc."\"></td></tr></span></td></tr>";
echo "<tr><td class=\"tcat\">Status</td></tr>";
$db->query("update `".TABLE_PREFIX."medals_awarded` set `status`= {$action} where `mid`={$mid} and `uid`={$uid}");
echo "<tr><td class=\"trow1\" colspan=\"2\">{$desc} <img src=\"{$imgsrc}\">";
if ($action == '0')
echo $lang->medal_suspended;
else if ($action == '1')
echo $lang->medal_unsuspended;
echo " for ".uid_to_username($uid);
echo "</table>";
show_medals_list($cuid,$footer);

}




// Helper Functions

function check_auth($mid,$cuid)
{

global $mybb,$db;

$supermod = $mybb->usergroup['issupermod'];
$authquery = $db->query("select count(*) as count from `".TABLE_PREFIX."medals_managers` where `uid`={$cuid} and `mid` ={$mid}");
$count = $db->fetch_field($authquery,"count");

	if($count >= 1 || $supermod == 'yes')
	return true;
	else
	return false;
	
}


function uid_to_username($uid)
{
global $db;
 $query = $db->query("SELECT username FROM ".TABLE_PREFIX."users WHERE uid='".$db->escape_string($uid)."' LIMIT 1");
        if($username = $db->fetch_field($query,"username"))
        {
                return $username;
        }
        else
        {
                return false;
        }
}

function username_to_uid($username)
{
global $db;
 $query = $db->query("SELECT uid FROM ".TABLE_PREFIX."users WHERE username='".$db->escape_string($username)."' LIMIT 1");
        if($uid = $db->fetch_field($query,"uid"))
        {
                return $uid;
        }
        else
        {
                return false;
        }
}

function mid_to_desc($mid)
{
global $db;
 $query = $db->query("SELECT `description` FROM ".TABLE_PREFIX."medals_list WHERE `mid`='".$db->escape_string($mid)."' LIMIT 1");
        if($desc = $db->fetch_field($query,"description"))
        {
                return $desc;
        }
        else
        {
                return false;
        }


}


echo $footer;

?>
